/* Copyright (c) 2005 PrimeBase Technologies GmbH
 *
 * PrimeBase XT
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * 2005-05-24	Paul McCullagh
 *
 * H&G2JCtL
 */
#ifndef __xt_cache_h__
#define __xt_cache_h__

//#define XT_USE_MYSYS

#include "filesys_xt.h"

struct XTOpenTable;

#ifdef DEBUG
//#define XT_USE_CACHE_DEBUG_SIZES
#endif

#ifdef XT_USE_CACHE_DEBUG_SIZES

#define XT_INDEX_CACHE_FILE_SLOTS			5
#define XT_INDEX_CACHE_SEGMENT_SHIFTS		1
#define XT_INDEX_CACHE_MAX_FLUSH_SEG_CNT	10
#define XT_INDEX_CACHE_MAX_FREE_COUNT		10

#else

#define XT_INDEX_CACHE_FILE_SLOTS			71
#define XT_INDEX_CACHE_SEGMENT_SHIFTS		3
#define XT_INDEX_CACHE_MAX_FLUSH_SEG_CNT	250
#define XT_INDEX_CACHE_MAX_FREE_COUNT		100

#endif

void	xt_ind_init(XTThreadPtr self, size_t cache_size);
void	xt_ind_exit(XTThreadPtr self);
xtInt8	xt_ind_get_usage();
xtInt8	xt_ind_get_size();
xtBool	xt_ind_flush(XTOpenFilePtr file, xtBool *something_written);
xtBool	xt_ind_write(XTOpenFilePtr file, off_t offset, size_t size, xtWord1 *data);
xtBool	xt_ind_write_thru(XTOpenFilePtr file, off_t offset, size_t size, xtWord1 *data);
xtBool	xt_ind_read(XTOpenFilePtr file, off_t offset, size_t size, xtWord1 *data);
xtBool	xt_ind_read_8(XTOpenFilePtr file, off_t offset, xtWord8 *data);
xtBool	xt_ind_read_block(XTOpenFilePtr file, off_t offset, xtWord1 *data);
void	xt_ind_check_cache(void);

#ifdef DEBUG
#define DEBUG_CHECK_CACHE
#endif

#endif
