/* Copyright (c) 2005 PrimeBase Technologies GmbH
 *
 * PrimeBase XT
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * 2005-01-03	Paul McCullagh
 *
 * H&G2JCtL
 */

#ifndef __xt_strutil_h__
#define __xt_strutil_h__

#include <string.h>

#include "xt_defs.h"

#ifdef XT_WIN
#define XT_DIR_CHAR					'\\'
#define XT_IS_DIR_CHAR(c)			((c) == '/' || (c) == '\\')
#else
#define XT_DIR_CHAR					'/'
#define XT_IS_DIR_CHAR(c)			((c) == '/')
#endif

#define MAX_INT8_STRING_SIZE		100

void	xt_strcpy(size_t size, char *to, c_char *from);
void	xt_strncpy(size_t size, char *to, c_char *from, size_t len_from);
void	xt_strcat(size_t size, char *to, c_char *from);
void	xt_strcati(size_t size, char *to, int i);
void	xt_strcpy_term(size_t size, char *to, c_char *from, char term);
void	xt_strcat_term(size_t size, char *to, c_char *from, char term);

xtBool	xt_ends_with(c_char *str, c_char *sub);
xtBool	xt_starts_with(c_char *str, c_char *sub);

char	*xt_last_name_of_path(c_char *path);
void	xt_2nd_last_name_of_path(size_t size, char *dest, c_char *path);
c_char	*xt_last_directory_of_path(c_char *path);
xtBool	xt_remove_dir_char(char *dir_name);
xtBool	xt_add_dir_char(size_t max, char *path);
void	xt_remove_last_name_of_path(char *path);
char	*xt_find_extension(c_char *file_name);
void	xt_remove_extension(char *file_name);
xtBool	xt_is_extension(c_char *file_name, c_char *ext);

xtInt8	xt_str_to_int8(c_char *ptr, xtBool *overflow);
void	xt_int8_to_str(xtInt8 value, char *string);
void	xt_double_to_str(double value, int scale, char *string);

xtInt8	xt_byte_size_to_int8(c_char *ptr);
void	xt_int8_to_byte_size(xtInt8 value, char *string);

c_char	*xt_get_version(void);

void xt_strcpy_url(size_t size, char *to, c_char *from);
void xt_strncpy_url(size_t size, char *to, c_char *from, ssize_t len_from);

const char		*xt_strchr(const char *str, char ch);
unsigned char	xt_hex_digit(char ch);

#endif
